#include <gtkmm.h>
#include <libglademm.h>
#include "mywidget.h"
#include <iostream>

/** Initialise the widgets so the GTypes are known */
void init_widgets() {
  MyWidget* dummy = new MyWidget();
  delete( dummy ); 
}

int main(int argc, char* argv[]) {
  Gtk::Widget* mywidget = 0L;
  Gtk::Window* mainwindow = 0L;
  Gtk::Main kit( argc,argv );

  // If commented out Glade does not know about our custom type.
  // If active, Glade does not produce that error anymore (so the
  // GType of the MyWidget is indeed registered) but a normal
  // Gtk::Label is constructed instead of the MyWidget.
  init_widgets();

  Glib::RefPtr<Gnome::Glade::Xml> gxml = Gnome::Glade::Xml::create("mywidget-example.glade");
  gxml->get_widget("mainwindow",mainwindow);
  gxml->get_widget("mywidget",mywidget);
  mainwindow->show();

  std::cout << "Type of Gtk::Label  : " << Gtk::Label::get_type() << std::endl;
  std::cout << "Type of MyWidget    : " << MyWidget::get_type() << std::endl;
  if( dynamic_cast<Gtk::Label*>(mywidget) )
    std::cout << "Found widget is of Gtk::Label type." << std::endl;
  else std::cout << "Found widget is NOT of Gtk::Label type." << std::endl;
  if( dynamic_cast<MyWidget*>(mywidget) )
    std::cout << "Found widget is of MyWidget type." << std::endl;
  else std::cout << "Found widget is NOT of MyWidget type." << std::endl;

  kit.run(*mainwindow);
  return 0;
}
